package code.name.monkey.retromusic.ui.adapter.song;

import android.support.annotation.LayoutRes;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import code.name.monkey.appthemehelper.ThemeStore;
import code.name.monkey.retromusic.R;
import code.name.monkey.retromusic.helper.MusicPlayerRemote;
import code.name.monkey.retromusic.interfaces.CabHolder;
import code.name.monkey.retromusic.model.Song;
import java.util.ArrayList;


public class ShuffleButtonSongAdapter extends AbsOffsetSongAdapter {

  public ShuffleButtonSongAdapter(AppCompatActivity activity, ArrayList<Song> dataSet,
      @LayoutRes int itemLayoutRes, boolean usePalette, @Nullable CabHolder cabHolder) {
    super(activity, dataSet, itemLayoutRes, usePalette, cabHolder);
  }

  @Override
  protected SongAdapter.ViewHolder createViewHolder(View view) {
    return new ViewHolder(view);
  }

  @Override
  public void onBindViewHolder(@NonNull final SongAdapter.ViewHolder holder, int position) {
    if (holder.getItemViewType() == OFFSET_ITEM) {
      int accentColor = ThemeStore.accentColor(activity);
      if (holder.title != null) {
        holder.title.setText(activity.getResources().getString(R.string.action_shuffle_all));
        holder.title.setTextColor(accentColor);
                /*((GradientTextView) holder.title).setLinearGradient(ThemeStore.accentColor(activity),
                        PhonographColorUtil.getMatColor(activity, "A400"), GradientTextView.LG_VERTICAL);
                */
      }
      if (holder.text != null) {
        holder.text.setVisibility(View.GONE);
      }
      if (holder.menu != null) {
        holder.menu.setVisibility(View.GONE);
      }
      if (holder.image != null) {
        final int padding =
            activity.getResources().getDimensionPixelSize(R.dimen.default_item_margin) / 2;
        holder.image.setPadding(padding, padding, padding, padding);
        holder.image.setColorFilter(accentColor);
        holder.image.setImageResource(R.drawable.ic_shuffle_white_24dp);
      }
      if (holder.separator != null) {
        holder.separator.setVisibility(View.VISIBLE);
      }
      if (holder.shortSeparator != null) {
        holder.shortSeparator.setVisibility(View.GONE);
      }
    } else {
      super.onBindViewHolder(holder, position - 1);
    }
  }

  public class ViewHolder extends AbsOffsetSongAdapter.ViewHolder {

    public ViewHolder(@NonNull View itemView) {
      super(itemView);
    }

    @Override
    public void onClick(View v) {
      if (getItemViewType() == OFFSET_ITEM) {
        MusicPlayerRemote.openAndShuffleQueue(dataSet, true);
        return;
      }
      super.onClick(v);
    }
  }
}